/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SimpleObservationMarshaller.java,v 87b44a903760 2010/07/10 14:20:45 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.semantic;

import javax.annotation.Nonnull;
import it.tidalwave.util.As;
import it.tidalwave.util.AsException;
import it.tidalwave.mobile.media.Media;
import it.tidalwave.bluebill.observation.Observation;
import it.tidalwave.bluebill.observation.ObservationItem;
import it.tidalwave.bluebill.observation.Observer;
import it.tidalwave.semantic.io.spi.AsStatementMarshaller;
import it.tidalwave.semantic.io.spi.StatementMarshaller.Context;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class SimpleObservationMarshaller extends AsStatementMarshaller
  {
    @Override @Nonnull
    public void marshal (final @Nonnull As entity, final @Nonnull Context context)
      {
        super.marshal(entity, context);
        final Observation observation = (Observation)entity;
        context.addStatement(observation, Vocabulary.RDF_TYPE, Vocabulary.OBSERVATION);
        context.addStatement(observation, Vocabulary.DC_DATE, observation.getDate());
        context.addStatement(observation, Vocabulary.MADE_AT, observation.getLocation());
        context.addStatement(observation, Vocabulary.DC_PUBLISHER, observation.getSource());

        for (final Observer observer : observation.findObservers().results())
          {
            context.addStatement(observation, Vocabulary.DC_CREATOR, observer);
          }

        for (final ObservationItem observationItem : observation.findObservationItems().results())
          {
            context.addStatement(observation, Vocabulary.SKOS_NARROWER, observationItem);
          }

        try
          {
            context.addStatement(observation.as(Media.class), Vocabulary.FOAF_TOPIC, observation);
          }
        catch (AsException e)
          {
            // ok, no attachment
          }
      }
  }
