/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: MediaUnmarshaller.java,v 950bc37500bd 2010/07/10 10:22:50 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.othermarshallers;

import javax.annotation.Nonnull;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.mobile.media.Media;
import it.tidalwave.semantic.io.impl.Converter;
import org.openrdf.model.Statement;
import it.tidalwave.semantic.io.spi.StatementUnmarshallerSupport;
import it.tidalwave.util.Id;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class MediaUnmarshaller extends StatementUnmarshallerSupport
  {
    @Override @Nonnull
    public As unmarshal (final @Nonnull List<Statement> statements, final @Nonnull Context context)
      {
        Media media = new Media().with(Media.ID, Converter.valueToId(statements.get(0).getSubject()));

        final String format = (String)getLiteral(statements, new Id(Media.FORMAT.stringValue()));

        if (format != null)
          {
            media = media.with(Media.FORMAT, format);
          }
        
        final String rights = (String)getLiteral(statements, new Id(Media.RIGHTS.stringValue()));

        if (rights != null)
          {
            media = media.with(Media.RIGHTS, rights);
          }

        return media;
      }
  }
